//definimos pines de los motores A,B,C y D
const int MotorA1 = 34; //DD
const int MotorA2 = 35;
const int PWMA = 12;

const int MotorB1 = 33; //DI
const int MotorB2 = 32;
const int PWMB = 11;

const int MotorC1 = 28; //TI
const int MotorC2 = 29;
const int PWMC = 9;

const int MotorD1 = 31; //TD
const int MotorD2 = 30;
const int PWMD = 10;

void setup() {
//Establecemos los pines de los motores como salidas
  pinMode(MotorA1, OUTPUT);
  pinMode(MotorA2, OUTPUT);
  
  pinMode(MotorB1, OUTPUT);
  pinMode(MotorB2, OUTPUT);

  pinMode(MotorC1, OUTPUT);
  pinMode(MotorC2, OUTPUT);
  
  pinMode(MotorD1, OUTPUT);
  pinMode(MotorD2, OUTPUT);
  
}

void loop() {
  //Adelante durante 2s
  avance();
  delay(2000);
  //Atrás durante 2s
  atras();
  delay(2000);
  //Giro izquierda durante 2s
  gira_izquierda();
  delay(2000);
  // Giro derecha durante 2s
  gira_derecha();
  delay(2000);
  //Detener 2s
  stop();
  delay(2000);

}

void avance() { //Adelante
//motor A gira en sentido de las agujas del reloj
  digitalWrite(MotorA1, HIGH);
  digitalWrite(MotorA2, LOW);
  analogWrite(PWMA, 255);  
//motor B gira en sentido de las agujas del reloj
  digitalWrite(MotorB1, HIGH);
  digitalWrite(MotorB2, LOW);
  analogWrite(PWMB, 255); 
//motor C gira en sentido de las agujas del reloj
  digitalWrite(MotorC1, HIGH);
  digitalWrite(MotorC2, LOW);
  analogWrite(PWMC, 255);  
//motor D gira en sentido de las agujas del reloj
  digitalWrite(MotorD1, HIGH);
  digitalWrite(MotorD2, LOW);
  analogWrite(PWMD, 255);  
}

void atras() { //Atras
//motor A gira en sentido contrario al de las agujas del reloj
  digitalWrite(MotorA1, LOW);
  digitalWrite(MotorA2, HIGH);
  analogWrite(PWMA, 255);  
//motor B gira en sentido contrario al de las agujas del reloj
  digitalWrite(MotorB1, LOW);
  digitalWrite(MotorB2, HIGH);
  analogWrite(PWMB, 255); 
//motor C gira en sentido contrario al de las agujas del reloj
  digitalWrite(MotorC1, LOW);
  digitalWrite(MotorC2, HIGH);
  analogWrite(PWMC, 255);  
//motor D gira en sentido contrario al de las agujas del reloj
  digitalWrite(MotorD1, LOW);
  digitalWrite(MotorD2, HIGH);
  analogWrite(PWMD, 255); 
}

void gira_izquierda() { //Giro a la izquierda
//motor A gira en sentido de las agujas del reloj
  digitalWrite(MotorA1, HIGH);
  digitalWrite(MotorA2, LOW);
  analogWrite(PWMA, 255);  
//motor B gira en sentido contrario al de las agujas del reloj
  digitalWrite(MotorB1, LOW);
  digitalWrite(MotorB2, HIGH);
  analogWrite(PWMB, 255); 
//motor C gira en sentido contrario al de las agujas del reloj
  digitalWrite(MotorC1, LOW);
  digitalWrite(MotorC2, HIGH);
  analogWrite(PWMC, 255);  
//motor D gira en sentido de las agujas del reloj
  digitalWrite(MotorD1, HIGH);
  digitalWrite(MotorD2, LOW);
  analogWrite(PWMD, 255);  
}

void gira_derecha() { //Giro a la derecha
//motor A gira en sentido contrario al de las agujas del reloj
  digitalWrite(MotorA1, LOW);
  digitalWrite(MotorA2, HIGH);
  analogWrite(PWMA, 255);  
//motor B gira en sentido de las agujas del reloj
  digitalWrite(MotorB1, HIGH);
  digitalWrite(MotorB2, LOW);
  analogWrite(PWMB, 255); 
//motor C gira en sentido de las agujas del reloj
  digitalWrite(MotorC1, HIGH);
  digitalWrite(MotorC2, LOW);
  analogWrite(PWMC, 255);  
//motor D gira en sentido contrario al de las agujas del reloj
  digitalWrite(MotorD1, LOW);
  digitalWrite(MotorD2, HIGH);
  analogWrite(PWMD, 255);  
}

void stop() { //Detener
//Establecer a 0 la velocidad de los 4 motores
  analogWrite(PWMA, 0);
  analogWrite(PWMB, 0);
  analogWrite(PWMC, 0);
  analogWrite(PWMD, 0);  
}